var Pag16000_EmprestimoLeasing_Controller = function(ScreenService, templateManager, General, ZHPromise, Pag16000_EmprestimoLeasing_Service, contabilizacaoController, ZhFilterPreferences) {

    var self = this;

    this.setFiltroPorEmpresa = function(widgetFiltro){
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var tabbed_emprestimo = templateManager.container.getWidget('tabbed_emprestimo');
        emprestimo.getField('NMFILIAL').dataSourceFilter[0].value = widgetFiltro.currentRow.CDEMPRESA;
        tabbed_emprestimo.getField('NMFILIAL').dataSourceFilter[0].value = widgetFiltro.currentRow.CDEMPRESA;
        widgetFiltro.getField('FILIORIG').dataSourceFilter[0].value = widgetFiltro.currentRow.CDEMPRESA;
    };

    //CONTROLE REPARCELAMENTO
    this.cancelarReparcelamento = function (args){
        var reparcelamento = args.owner.widget;
        if (reparcelamento.currentRow.edit){
            reparcelamento.currentRow.edit = false;
            reparcelamento.currentRow = angular.copy(reparcelamento.backupRow);
            args.owner.widget.view();
            var existeNovaParcela = reparcelamento.dataSource.data.filter(function(parcela){
                return parcela.__createdLocal;
            });
            if ((reparcelamento.dataSource.data.length == 1) || ((existeNovaParcela.length == 0) && !(reparcelamento.NOVOREPARCELAMENTO))){
                General.changeWidgetAcessibility(reparcelamento.widgets, true);
            }
        }else{
            General.backOrCancel(args).then(function(){
                if (reparcelamento.dataSource.data.length == 1){
                    reparcelamento.NOVOREPARCELAMENTO = false;
                }
            });
        }
    };

    this.adicionaParcela = function(reparcelamento){
        var parcelas = reparcelamento.getParent().getParent();
        if (this.validaAdicaoParcela(reparcelamento)){
            var sequencial = parcelas.currentRow.NRSEQVENPAG;
            var vencimento = parcelas.currentRow.DTATUAVENPAG;
            var numeroParcela = reparcelamento.dataSource.data.length.toString().padStart(2, "0");
            var descricao = parcelas.currentRow.DSCONTAPAG;
            this.novoParcelamento(reparcelamento).then(function(){
                var valoresNovoParcelamento = this.calculaNovosValoresReparcelamento(reparcelamento);
                diferencaValorConta = valoresNovoParcelamento[0];
                diferencaValorBoleto = valoresNovoParcelamento[1];
                diferencaAjuste = valoresNovoParcelamento[2];
                    this.setRowReparcelamento(reparcelamento, diferencaValorBoleto, diferencaAjuste, sequencial, numeroParcela, vencimento, descricao, diferencaValorConta);
                    reparcelamento.currentRow.edit = false;
            }.bind(this));
        }
    };

    this.setRowReparcelamento = function(reparcelamento, diferencaValorBoleto, diferencaAjuste, sequencial, numeroParcela, vencimento, descricao, diferencaValorConta){
        reparcelamento.NOVOREPARCELAMENTO = true;
        reparcelamento.currentRow.VRFINALBPAG = diferencaValorBoleto;
        reparcelamento.currentRow.VRAJUSTE = diferencaAjuste;
        reparcelamento.currentRow.NRSEQVENPAG = sequencial;
        reparcelamento.currentRow.NRPARCELAPAG = numeroParcela;
        reparcelamento.currentRow.DTATUAVENPAG = vencimento;
        reparcelamento.currentRow.DSCONTAPAG = descricao;
        reparcelamento.currentRow.VRATUAPAG = diferencaValorConta;
        reparcelamento.backupRow = {};
        reparcelamento.backupRow.VRATUAPAG = diferencaValorConta;
        reparcelamento.backupRow.VRAJUSTE = diferencaAjuste;
        reparcelamento.backupRow.VRFINALBPAG = diferencaValorBoleto;
    };

    this.calculaNovosValoresReparcelamento = function(reparcelamento){
        var parcelas = reparcelamento.getParent().getParent();
        var sequencial = parcelas.currentRow.NRSEQVENPAG;
        var totalConta = 0;
        var totalAjusteParcela = 0;
        var totalContaReparcelamento = 0;
        var totalAjusteReparcelamento = 0;
        var diferencaValorConta = 0;
        var diferencaValorBoleto = 0;
        var diferencaAjuste = 0;
        parcelas.dataSource.data.forEach(function(data){
            if (data.NRSEQVENPAG == sequencial){
                var valorConta = data.VRATUAPAG;
                valorConta = (valorConta.toString().search(',') == -1) ? parseFloat(valorConta) : parseFloat(valorConta.toString().replace('.', '').replace(',', '.'));
                totalConta = (parseFloat(totalConta) + parseFloat(valorConta)).toFixed(2);
                var valorAjuste = (data.VRAJUSTE) ? parseFloat(data.VRAJUSTE) : 0;
                totalAjusteParcela = (parseFloat(totalAjusteParcela) + valorAjuste).toFixed(2);
            }
        });
        reparcelamento.dataSource.data.forEach(function(data){
            if (data.NRSEQVENPAG == sequencial){
                var valorContaReparcelamento = data.VRATUAPAG;
                valorContaReparcelamento = (valorContaReparcelamento.toString().search(',') == -1) ? parseFloat(valorContaReparcelamento) : parseFloat(valorContaReparcelamento.toString().replace('.', '').replace(',', '.'));
                totalContaReparcelamento = (parseFloat(totalContaReparcelamento) + valorContaReparcelamento).toFixed(2);
                var valorAjusteReparcelamento = data.VRAJUSTE;
                valorAjusteReparcelamento = (valorAjusteReparcelamento.toString().search(',') == -1) ? parseFloat(valorAjusteReparcelamento) : parseFloat(valorAjusteReparcelamento.toString().replace('.', '').replace(',', '.'));
                totalAjusteReparcelamento = (parseFloat(totalAjusteReparcelamento) + valorAjusteReparcelamento).toFixed(2);
            }
        });
        if (parseFloat(totalConta) != parseFloat(totalContaReparcelamento)){
            diferencaValorConta = (parseFloat(totalConta) - parseFloat(totalContaReparcelamento)).toFixed(2);
            diferencaValorBoleto = (parseFloat(totalConta) - parseFloat(totalContaReparcelamento) + (parseFloat(totalAjusteParcela) - parseFloat(totalAjusteReparcelamento))).toFixed(2);
            diferencaAjuste = (parseFloat(totalAjusteParcela) - parseFloat(totalAjusteReparcelamento)).toFixed(2);
            diferencaValorConta = (diferencaValorConta < 0) ? 0 : diferencaValorConta;
        }
        return [diferencaValorConta, diferencaValorBoleto, diferencaAjuste];
    };

    /*this.recalcularParcelasPosteriores = function(reparcelamento){
        var indice = reparcelamento.currentRow.__index;
        var data = reparcelamento.dataSource.data.filter(function(parc){
            return parc.__index > indice;
        });
        var totalContaPagar = 0;
        var totalAjuste = 0;
        reparcelamento.dataSource.data.forEach(function(parc){
            if (parc.__index <= indice){
                totalContaPagar = parseFloat(totalContaPagar) + parseFloat(parc.VRATUAPAG);
                totalAjuste = parseFloat(totalAjuste) + parseFloat(parc.VRAJUSTE);
            }
        });
        data.forEach(function(data){
            reparcelamento.dataSource.data.forEach(function(parc){
                if (parc.__index <= indice){
                    totalContaPagar = parseFloat(totalContaPagar) + parseFloat(parc.VRATUAPAG);
                    totalAjuste = parseFloat(totalAjuste) + parseFloat(parc.VRAJUSTE);
                }
            });
            var valorContaAtual = data.VRATUAPAG;
            var percentual = (totalContaPagar == 0) ? 0 : parseFloat((valorContaAtual * 100 / totalContaPagar).toFixed(2));
            data.VRAJUSTE = (totalAjuste * percentual / 100).toFixed(2);
            data.VRFINALBPAG = (parseFloat(valorContaAtual) + parseFloat(data.VRAJUSTE)).toFixed(2);
            totalContaPagar = 0;
            totalAjuste = 0;
            indice++;
        });
    };*/

    this.setValoresAjusteEBoleto = function(reparcelamento){
        var valorContaAtual = parseFloat(reparcelamento.currentRow.VRATUAPAG.toString().replace('.', '').replace(',', '.'));
        var valorContaAnterior = (reparcelamento.backupRow.VRATUAPAG) ? parseFloat(reparcelamento.backupRow.VRATUAPAG) : 0;
        var percentual = (valorContaAnterior == 0) ? 0 : parseFloat((valorContaAtual * 100 / valorContaAnterior).toFixed(2));
        var valorAjuste = reparcelamento.backupRow.VRAJUSTE;
        valorAjuste = (valorAjuste) ? parseFloat(reparcelamento.backupRow.VRAJUSTE) : 0.00;
        reparcelamento.currentRow.VRAJUSTE = (valorAjuste * percentual / 100).toFixed(2);
        reparcelamento.currentRow.VRFINALBPAG = (valorContaAtual + parseFloat(reparcelamento.currentRow.VRAJUSTE)).toFixed(2);
    };

    this.validaAdicaoParcela = function(reparcelamento){
        var adicaoPermitida = true;
        var parcelasPersistidas = reparcelamento.dataSource.data.filter(function(f){return !f.__is_new;});
        if (!parcelasPersistidas[parcelasPersistidas.length - 1].hasOwnProperty('changed')){
            adicaoPermitida = false;
            ScreenService.showMessage("Operação Bloqueada. Inclusão permitida somente após edição da última parcela.");
        }
        return adicaoPermitida;
    };

    this.salvarParcelas = function(reparcelamento){
        var valorConta = reparcelamento.currentRow.VRATUAPAG;
        valorConta = (valorConta.toString().search(',') == -1) ? parseFloat(valorConta) : parseFloat(valorConta.toString().replace('.', '').replace(',', '.'));
        if (reparcelamento.currentRow.edit){
            reparcelamento.currentRow.edit = false;
            reparcelamento.view();
            reparcelamento.NOVOREPARCELAMENTO = true;
            this.validaVisibilidadeDeleteParcelas(reparcelamento);
            //this.recalcularParcelasPosteriores(reparcelamento);
        }else{
            if (valorConta > 0){
                ScreenService.closeSwipe().then(function(){
                    reparcelamento.NOVOREPARCELAMENTO = true;
                    reparcelamento.list();
                    reparcelamento.currentRow.edit = false;
                    this.validaVisibilidadeDeleteParcelas(reparcelamento);
                }.bind(this));
            }else{
                ScreenService.showMessage("Valor da conta deve ser maior que zero.");
            }
        }
    };

    this.editarReparcelamento = function(reparcelamento){
        var data = reparcelamento.dataSource.data;
        var route = 'fin_contaPagar#/validaPermissaoEdicaoTitulo';
        var DataPersistida = data.filter(function(data){
            return !data.hasOwnProperty('__createdLocal');
        });
        var ultimaParcelaPersistida = DataPersistida.length - 1;
        if (data.length > 1){
            if (reparcelamento.currentRow.hasOwnProperty('__createdLocal')){
                this.executaEdit(reparcelamento);
            }else{
                General.callRestEngine(route, 'Row', reparcelamento.currentRow).then(function(){
                    if (reparcelamento.currentRow.__index == ultimaParcelaPersistida){
                        this.executaEdit(reparcelamento);
                    }else{
                        ScreenService.showMessage('Operação Bloqueada. É permitido a edição apenas da última parcela do título.');
                    }
                }.bind(this))
                .catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
            }
        }else{
            if (reparcelamento.currentRow.hasOwnProperty('__createdLocal')){
                this.executaEdit(reparcelamento);
            }else{
                General.callRestEngine(route, 'Row', reparcelamento.currentRow)
                .then(function(){
                    this.executaEdit(reparcelamento);
                }.bind(this))
                .catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
            }
        }
    };

    this.deleteReparcelamentoEmprestimoPagar = function (args) {
        var reparcelamento = templateManager.container.getWidget('reparcelamento');
        if (reparcelamento.dataSource.data.length > 1){
            if (!reparcelamento.currentRow.__createdLocal) {
                var ultimaParcela = reparcelamento.dataSource.data.length - 1;
                if (reparcelamento.currentRow.__index == ultimaParcela){
                    this.removeUltimaParcela(reparcelamento);
                }else{
                    ScreenService.showMessage('Operação Bloqueada. Somente é permitido a exclusão da última parcela do título.');
                }
            }else{
                this.remocaoLogicaParcelas(args);
            }
        }else{
            ScreenService.showMessage('Operação Bloqueada. Não é possível excluir a parcela original.');
        }
    };

    this.remocaoLogicaParcelas = function(args){
        General.backOrCancel(args);
    };

    this.removeUltimaParcela = function(reparcelamento){
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var route = 'fin_contaPagar#/deleteReparcelamentoEmprestimoPagar';
        var parcelas = reparcelamento.getParent().getParent();
        this.emprestimoRealizadoNoPeriodoContabil(emprestimo).then(function(){
            ScreenService.confirmMessage(ScreenService.i18n('Confirmar exclusão da última parcela?'), 'question', function () {
                reparcelamento.dataSource.data.forEach(function(data){
                    data.CDAJUCTPAG = emprestimo.currentRow.CDAJUCTPAG;
                });
                General.callRestEngine(route, 'DataSet', reparcelamento.dataSource.data)
                    .then(function () {
                        var nrseqvenpag = reparcelamento.currentRow.NRSEQVENPAG;
                        ScreenService.closeSwipe().then(function(){
                            parcelas.reload().then(function(){
                                var rowsParcela = parcelas.dataSource.data.filter(function(parcela){
                                    return parcela.NRSEQVENPAG == nrseqvenpag;
                                });
                                var sequenciaisParcela = rowsParcela.map(function(m){return m.NRPARCELAPAG;});
                                var parcelaReferencia = sequenciaisParcela.reduce(function(a, b) {
                                    return Math.max(a, b);
                                });
                                var currentRow = rowsParcela.filter(function(parcela){
                                    return parcela.NRPARCELAPAG == parcelaReferencia.toString().padStart(2, "0");
                                })[0];
                                parcelas.currentRow = currentRow;
                            });
                            reparcelamento.reload();
                            ScreenService.showMessage('Registro excluído com sucesso!');
                            this.validaVisibilidadeDeleteParcelas(reparcelamento);
                        }.bind(this));
                    }.bind(this))
                    .catch(function (response) {
                        ScreenService.showMessage(response.data.error);
                    });
            }.bind(this));
        }.bind(this))
        .catch(function (error) {
            ScreenService.showMessage(error);
        });

    };
    //CONTROLE REPARCELAMENTO
    this.setEmpresaStripe = function(filtro){
        var stripe = templateManager.container.getWidget('stripe');
        stripe.currentRow.EMPRESA = ": " + filtro.FILTER_ROW.CDEMPRESA + " - " + filtro.FILTER_ROW.NMEMPRESA;
    };

    this.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filtroFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filtroFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;
            var routeEmpresa = 'fin#/crud/empresa';
            var filtroEmpresa = [{"name": "CDEMPRESA", "operator": "=", "value": cdempresa}];
            General.callRestEngine(routeEmpresa, 'FilterData', filtroEmpresa).then(function (response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                var cdempresa = empresa.CDEMPRESA;
                var nmempresa = empresa.NMEMPRESA;
                deferred.resolve(empresa);
            }.bind(this));
        }.bind(this));
        return deferred.promise;
    };

    this.setPrimeiroVencimento = function(parcelasGrid){
        var tabbed_emprestimo = parcelasGrid.getParent();
        if (parcelasGrid.currentRow.__index == 0){
            var data = parcelasGrid.currentRow.DTATUAVENPAG_inline;
            if (data.toString().search('/') == -1){
                parcelasGrid.currentRow.DTATUAVENPAG_inline = data.substr(0, 2) + '/' + data.substr(2, 2) + '/' + data.substr(4, 4);
            }
            tabbed_emprestimo.currentRow.DTPRIVENCEMP = parcelasGrid.currentRow.DTATUAVENPAG_inline;
        }
    };

    this.setQtdeParcelas = function(parcelas){
        var emprestimo = templateManager.container.getWidget('emprestimo');
        emprestimo.currentRow.PARCELAS = parcelas.dataSource.data.length;
    };

    this.controlaVisibilidadeActionContabilizacao = function(widget){
        if (widget.currentRow.NRLCTBMDEB){
            widget.getAction('ConsultarCtbEmprestimoDebito').isVisible = true;
        }else{
            widget.getAction('ConsultarCtbEmprestimoDebito').isVisible = false;
        }
        if (widget.currentRow.NRLCTBMCRED){
            widget.getAction('ConsultarCtbEmprestimoCredito').isVisible = true;
        }else{
            widget.getAction('ConsultarCtbEmprestimoCredito').isVisible = false;
        }
    };

    this.controlaVisibilidadeActionEdicao = function(widget){
        if (widget.dataSource.data > 0){
            widget.getAction('editar').isVisible = true;
        }else{
            widget.getAction('editar').isVisible = false;
        }
    };

    this.controlaVisibilidadeContabilizacaoPagamento = function(widget){
        if (widget.currentRow.NRLANCTBDOC){
            widget.getAction('ConsultarCtbEmprestimoPagamento').isVisible = true;
        }else{
            widget.getAction('ConsultarCtbEmprestimoPagamento').isVisible = false;
        }
    };

    this.consultaContabilizacaoEmprestimoPagamento = function(){
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var contabil = [{
            "CDEMPRESA": emprestimo.currentRow.CDEMPRESA,
            "NRLANCCONT": emprestimo.currentRow.NRLANCTBDOC
        }];
        contabilizacaoController.exibeContabilizacao(contabil);
    };

    this.consultaContabilizacaoEmprestimoDebito = function(){
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var credito = templateManager.container.getWidget('lancamentoIof');
        var contabil = [{
            "CDEMPRESA": emprestimo.currentRow.CDEMPRESA,
            "NRLANCCONT": credito.currentRow.NRLCTBMDEB
        }];
        contabilizacaoController.exibeContabilizacao(contabil);
    };

    this.consultaContabilizacaoEmprestimoCredito = function(){
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var credito = templateManager.container.getWidget('lancamentoIof');
        var contabil = [{
            "CDEMPRESA": emprestimo.currentRow.CDEMPRESA,
            "NRLANCCONT": credito.currentRow.NRLCTBMCRED
        }];
        contabilizacaoController.exibeContabilizacao(contabil);
    };

    this.setDescricaoCredito = function(widget){
        if (!widget.currentRow.DSMOVICRED){
            widget.currentRow.DSMOVICRED = widget.currentRow.DSTPCREDBANC;
        }
    };

    this.setDescricaoDebito = function(widget){
        if (!widget.currentRow.DSMOVIDEBI){
            widget.currentRow.DSMOVIDEBI = widget.currentRow.DSTPDEBIBANC;
        }
    };

    this.editarCredito = function(widget){
        General.widgetEdit(widget);
        if (widget.getField('DEBIOF').value() == 'S'){
            widget.getField('DEBIOF').readOnlyOnEdit = false;
            widget.getField('NRDOCMBANC').readOnlyOnEdit = false;
            widget.getField('DSMOVIDEBI').readOnlyOnEdit = false;
        }else{
            widget.getField('DEBIOF').setValue('N');
            widget.getField('DEBIOF').readOnlyOnEdit = true;
            widget.getField('NRDOCMBANC').readOnlyOnEdit = true;
            widget.getField('DSMOVIDEBI').readOnlyOnEdit = true;
        }
        if (widget.getField('CREDITO').value() == 'S'){
            widget.getField('CREDITO').readOnlyOnEdit = false;
            widget.getField('NRDOCMBANCCRED').readOnlyOnEdit = false;
            widget.getField('DSMOVICRED').readOnlyOnEdit = false;
        }else{
            widget.getField('CREDITO').setValue('N');
            widget.getField('CREDITO').readOnlyOnEdit = true;
            widget.getField('NRDOCMBANCCRED').readOnlyOnEdit = true;
            widget.getField('DSMOVICRED').readOnlyOnEdit = true;
        }
    };

    this.setContaCorrenteCredito = function(widget){
        if (widget.getField('DSCONTCORR').value()){
            widget.getField('DSCONTCORRCRED').setValue(widget.getField('DSCONTCORR').value());
            widget.getField('CDAGENCIACRED').setValue(widget.getField('CDAGENCIA').value());
            widget.getField('CDCONTCORRCRED').setValue(widget.getField('CDCONTCORR').value());
            widget.getField('CDBANCOCRED').setValue(widget.getField('CDBANCO').value());
            widget.currentRow.CDREDUCONTCRED = widget.currentRow.CDREDUCONT;
            widget.currentRow.CDCONTCTBLCRED = widget.currentRow.CDCONTCTBL;
            widget.currentRow.IDTIPOCCORRCRED = widget.currentRow.IDTIPOCCORR;
            widget.getField('DSCONTCORRCRED').readOnlyOnEdit = true;
            widget.getField('CDAGENCIACRED').readOnlyOnEdit = true;
            widget.getField('CDCONTCORRCRED').readOnlyOnEdit = true;
            widget.getField('CDBANCOCRED').readOnlyOnEdit = true;
        }else{
            widget.getField('DSCONTCORRCRED').readOnlyOnEdit = false;
            widget.getField('CDAGENCIACRED').readOnlyOnEdit = false;
            widget.getField('CDCONTCORRCRED').readOnlyOnEdit = false;
            widget.getField('CDBANCOCRED').readOnlyOnEdit = false;
        }
    };

    this.saveCreditoEmprestimoPagar = function(widget){
        var route = 'fin_contaPagar#/saveCreditoEmprestimoPagar';
        General.callRestEngine(route, 'Row', widget.currentRow).then(function () {
            if (General.formWidgetSwitchTemplate(widget) && widget.getParent()) {
                var widgets = widget.getParent().widgets;
                General.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
            }
            widget.currentRow.changed = false;
            delete widget.backupRow;
            widget.view();
        }.bind(this), function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.voltarECancelReparcelamento = function(reparcelamento){
        ScreenService.goBack().then(function(){
            reparcelamento.NOVOREPARCELAMENTO = false;
            General.changeWidgetAcessibility(reparcelamento.widgets, true);
            reparcelamento.getParent().getParent().activate();
        });
    };

    this.iniciaFiltroPagamento = function(widget){
        this.buscaPadraoEmpresa(widget).then(function(empresa){
            var data = moment().format('DD/MM/YYYY');
            var start = moment().startOf('month').format('DD/MM/YYYY');
            var end   = moment().endOf('month').format('DD/MM/YYYY');
            var rowFilter = {};
            if (empresa.hasOwnProperty('CDEMPRESA')){
                rowFilter = {
                    'DTPRIVENCEMP': {start : start, end : end},
                    'DTEMPRESTIMO': {start : start, end : end},
                    'CDEMPRESA': empresa.CDEMPRESA,
                    'NMEMPRESA': empresa.NMEMPRESA,
                    'IDSTATPAG'   : 'T',
                    'SITUACAO'    : '',
                    'IDSTATUS'    : 'T'
                };
            }else{
                rowFilter = {
                    'DTPRIVENCEMP': {start : start, end : end},
                    'DTEMPRESTIMO': {start : start, end : end},
                    'IDSTATPAG'   : 'T',
                    'SITUACAO'    : '',
                    'IDSTATUS'    : 'T'
                };
            }
            widget.getField('DSTPCTPAGAR').dataSourceFilter[1].value = empresa.CDEMPRESA;
            widget.getField('DSTPCTPAGAR').reload();
            
            this.openFiltro(widget, rowFilter);
        }.bind(this));
    };

    this.openFiltro = function(widget, rowFilter){
        var deferred = ZHPromise.defer();
        ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
        ZhFilterPreferences.openFilterWidget(widget, rowFilter);
        deferred.resolve();
        return deferred.promise;
    };

    this.validaVisibilidadeDeleteParcelas = function(widget){
        if (widget.NOVOREPARCELAMENTO){
            widget.getAction('CONFIRMAR').isVisible = true;
        }else{
            widget.getAction('CONFIRMAR').isVisible = false;
        }
    };

    this.validaDisponibilidadeDebCredIOF = function(widget, agrupamento){
        var naoValidar = ['CDBANCO', 'CDAGENCIA', 'CDCONTCORR', 'CDBANCOCRED', 'CDAGENCIACRED', 'CDCONTCORRCRED', 'NRDOCMBANC', 'NRDOCMBANCCRED', agrupamento];
        var somenteLeitura = (widget.getField(agrupamento).value() == 'S') ? false : true;
        var validations = (widget.getField(agrupamento).value() == 'S') ? {"required": true} : {};
        widget.fields.forEach(function(field){
            if (!naoValidar.includes(field.name) && field.fieldGroup == agrupamento){
                field.readOnlyOnEdit = somenteLeitura;
                field.validations = validations;
            }
        });
        if (agrupamento == 'CREDITO' ){
            widget.currentRow.DTMOVICRED = (somenteLeitura) ? null : moment().format('DD/MM/YYYY');
            if (widget.getField(agrupamento).value() == 'S'){
                widget.getField('NRDOCMBANCCRED').readOnlyOnEdit = false;
            }else{
                widget.getField('NRDOCMBANCCRED').readOnlyOnEdit = true;
            }
        }
        if (agrupamento == 'DEBIOF' ){
            if (widget.getField(agrupamento).value() == 'S'){
                widget.getField('NRDOCMBANC').readOnlyOnEdit = false;
            }else{
                widget.getField('NRDOCMBANC').readOnlyOnEdit = true;
            }
            widget.currentRow.DTMOVIDEBI = (somenteLeitura) ? null : moment().format('DD/MM/YYYY');
        }
        this.setValorCredito();
        
        templateManager.updateTemplate();
    };

    this.setDocumento = function(args) {
        var emprestimo = args.owner.field.widget.container.getWidget('tabbed_emprestimo');

       /* emprestimo.getField('CDSERIE').value('');
        emprestimo.getField('DSSERIE').value('');
        emprestimo.getField('NRNOTAFISC').value('');*/

        var nrtamnumnfut = (emprestimo.currentRow.NRTAMNUMNFUTDFE > 0) ? emprestimo.currentRow.NRTAMNUMNFUTDFE : 9;
        emprestimo.getField('NRNOTAFISC').maxlength = nrtamnumnfut;

        if(emprestimo.getField('NMFILIAL').value()){
            var currentRow = {
                NRORG      : getLocalVar('NRORG'),
                CDCONTADOR : 'NRNOTAFISCPAG'
            };
            var route = 'fin_contaPagar#/geraNovoCodigo';
            General.callRestEngine(route, 'Row', currentRow).then(function (novocodigo) {
                var nrnotafisc = novocodigo.dataset.geraNovoCodigo.novocodigo.slice(-nrtamnumnfut);
                emprestimo.getField('NRNOTAFISC').setValue(nrnotafisc);
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    this.validaDatacontratoMenorVencimento = function(widget){
        var dataValida = true;
        var arrayVencimento = widget.currentRow.DTPRIVENCEMP.split('/');
        var arrayContrato = widget.currentRow.DTEMPRESTIMO.split('/');
        var anoVencimento = arrayVencimento.pop();
        var mesVencimento = arrayVencimento.pop();
        var diaVencimento = arrayVencimento.pop();
        var anoContrato = arrayContrato.pop();
        var mesContrato = arrayContrato.pop();
        var diaContrato = arrayContrato.pop();
        var dataVencimento = parseInt(anoVencimento.concat(mesVencimento.concat(diaVencimento)));
        var dataContrato = parseInt(anoContrato.concat(mesContrato.concat(diaContrato)));
        if (dataVencimento < dataContrato){
            dataValida = false;
            ScreenService.showMessage('Data do Primeiro Vencimento deve ser maior ou igual a data do Contrato.');
        }
        return dataValida;
    };

    this.carregaGridParcelas = function(){
        var parcelasGrid = templateManager.container.getWidget('parcelasGrid');
        var emprestimo = templateManager.container.getWidget('tabbed_emprestimo');
        var numeroParcelas = parseFloat(emprestimo.currentRow.PARCELAS);
        var totalEmprestimo = emprestimo.currentRow.VRTOTALEMP;
        if (totalEmprestimo){
            totalEmprestimo = (totalEmprestimo.toString().search(',') != -1) ? parseFloat(totalEmprestimo.toString().replace('.', '').replace(',', '.')) : parseFloat(totalEmprestimo);
        }else{
            totalEmprestimo = 0;
        }
        var tipoConta = emprestimo.currentRow.DSTPCTPAGAR;
        var dataIncrement = '';
        var data = emprestimo.currentRow.DTPRIVENCEMP.split('/');
        if (data){
             var dia = data[0].toString();
            var mes = data[1].toString();
            var ano = data[2].toString();
            dataIncrement = moment(mes + "/" + dia + "/" + ano);
        }
        emprestimo.VALORPARCELA = (totalEmprestimo/numeroParcelas);
        var sistemaAmortizacao = emprestimo.currentRow.IDTIPOEMP;
        var taxaJuros = self.formataValoresDecimais(emprestimo.currentRow.VRTXJUROSEMP);

        if ((numeroParcelas) && (totalEmprestimo > 0) && (tipoConta)){
             if (this.emprestimoValido(emprestimo)){
                if (taxaJuros == 0){
                    emprestimo.currentRow.VRTOTALAJUSTEMP = 0;
                }
                var listaParcelas = Pag16000_EmprestimoLeasing_Service.efetuaCalculoParcelas(
                    parseFloat(numeroParcelas), parseFloat(totalEmprestimo), tipoConta, parseFloat(emprestimo.currentRow.VRTOTALAJUSTEMP), dataIncrement, sistemaAmortizacao, taxaJuros
                    );
                parcelasGrid.dataSource.data = listaParcelas;
                var totalJuros = 0;
                listaParcelas.forEach(function(parcelas){
                    totalJuros = parseFloat(totalJuros) + parseFloat(parcelas.VRAJUSTE);
                });
                emprestimo.currentRow.VRTOTALAJUSTEMP = totalJuros;
            }
        }else{
            parcelasGrid.dataSource.data = [];
        }
    };

    this.emprestimoValido = function(emprestimo){
        var emprestimoValido = true;
        var numeroParcelas = parseFloat(emprestimo.currentRow.PARCELAS);
        var totalEmprestimo = parseFloat(emprestimo.currentRow.VRTOTALEMP.toString().replace('.', '').replace(',', '.')).toFixed(2);
        var valorMinimoParcelas = 0.01;
        if ((totalEmprestimo / numeroParcelas) < valorMinimoParcelas){
            emprestimoValido = false;
            ScreenService.showMessage('Valor total do empréstimo não pode ser dividido para o número de parcelas informadas.');
        }

        return emprestimoValido;
    };

    this.setValorCredito = function(){
        var tabbed_emprestimo = templateManager.container.getWidget('tabbed_emprestimo');
        var credito = templateManager.container.getWidget('credito');
        if (credito.getField('CREDITO').value() == 'S'){
            credito.getField('VRMOVICRED').setValue(tabbed_emprestimo.getField('VRTOTALEMP').value());
        }
        if (tabbed_emprestimo.getField('VRTOTALEMP').value() == 0){
            ScreenService.showMessage('Valor total do empréstimo deve ser maior do que 0.');
        }
    };

    this.setValoresAjusteEBoleto = function(reparcelamento){
        var valorContaAtual = parseFloat(reparcelamento.currentRow.VRATUAPAG.toString().replace('.', '').replace(',', '.'));
        var valorContaAnterior = (reparcelamento.backupRow.VRATUAPAG) ? parseFloat(reparcelamento.backupRow.VRATUAPAG) : 0;
        var percentual = (valorContaAnterior == 0) ? 0 : parseFloat((valorContaAtual * 100 / valorContaAnterior).toFixed(2));
        var valorAjuste = reparcelamento.backupRow.VRAJUSTE;
        valorAjuste = (valorAjuste) ? parseFloat(reparcelamento.backupRow.VRAJUSTE) : 0.00;
        reparcelamento.currentRow.VRAJUSTE = (valorAjuste * percentual / 100).toFixed(2);
        reparcelamento.currentRow.VRFINALBPAG = (valorContaAtual + parseFloat(reparcelamento.currentRow.VRAJUSTE)).toFixed(2);
    };

    this.novoParcelamento = function(reparcelamento){
        var deferred = ZHPromise.defer();
        reparcelamento.newRow();
        deferred.resolve();
        return deferred.promise;
    };

    this.alteraValorBoletoConta = function(widget){
        var indice = widget.currentRow.__index;
        var data = widget.dataSource.data;
        var valorConta = widget.currentRow.VRATUAPAG_inline;
        valorConta = (valorConta.toString().search(',') == -1) ? parseFloat(valorConta) : parseFloat(valorConta.toString().replace('.', '').replace(',', '.'));
        data[indice].VRFINALBPAG = (parseFloat(data[indice].VRAJUSTE) + parseFloat(valorConta)).toFixed(2);
    };

    this.alteraValorBoletoAjuste = function(widget){
        var indice = widget.currentRow.__index;
        var data = widget.dataSource.data;
        data[indice].VRFINALBPAG = (parseFloat(widget.currentRow.VRAJUSTE_inline.toString().replace('.', '').replace(',', '.')) + parseFloat(data[indice].VRATUAPAG)).toFixed(2);
    };

    this.aplicaJurosAoAjusteEBoleto = function(field){
        var emprestimo = templateManager.container.getWidget('tabbed_emprestimo');
        var valorTotalEmprestimo = emprestimo.currentRow.VRTOTALEMP;
        if (valorTotalEmprestimo){
            if (valorTotalEmprestimo > 0){
                var parcelasGrid = templateManager.container.getWidget('parcelasGrid');
                if (emprestimo.getField('IDTIPOEMP').value() == "O"){
                    if (field.name == 'VRTOTALAJUSTEMP'){
                        emprestimo.currentRow.VRTXJUROSEMP = (parseFloat(emprestimo.currentRow.VRTOTALAJUSTEMP).toFixed(2) * 100 / parseFloat(emprestimo.currentRow.VRTOTALEMP).toFixed(2));
                    }else{
                        valorTotalEmprestimo = (valorTotalEmprestimo.toString().search(',') != -1) ? parseFloat(valorTotalEmprestimo.replace('.', '').replace(',', '.')) : parseFloat(valorTotalEmprestimo);
                        emprestimo.currentRow.VRTOTALAJUSTEMP = ((parseFloat(emprestimo.currentRow.VRTXJUROSEMP) * valorTotalEmprestimo).toFixed(2) / 100).toFixed(2);
                    }
                }
                this.carregaGridParcelas();
            }
        }
    };

    this.validaValorAjuste = function(widget){
        if (widget.currentRow.IDTIPOEMP == 'O'){
            widget.getField('VRTOTALAJUSTEMP').readOnlyOnEdit = false;
        }else{
            widget.getField('VRTOTALAJUSTEMP').readOnlyOnEdit = true;
        }
        widget.getField('VRTXJUROSEMP').setValue(0);
        widget.getField('VRTOTALAJUSTEMP').setValue(0);
    };

    this.setValidationsTipoAjuste = function(widget){
        var valorJuros = widget.getField('VRTOTALAJUSTEMP');
        var tipoAjuste = widget.getField('DSAJUCTPAG');
        if (valorJuros.value() > 0){
            tipoAjuste.validations = {"required": true};
            tipoAjuste.readOnlyOnEdit =  false;
        }else{
            tipoAjuste.validations = {};
            tipoAjuste.readOnlyOnEdit = true;
        }
    };

    this.aplicaFiltroEStripe = function(emprestimo){
        this.aplicaFiltro(emprestimo, emprestimo.appliedFilter).then(function(){
            this.setEmpresaStripe(emprestimo.appliedFilter);
        }.bind(this));
    };

    this.aplicaFiltro = function (popupFilter) {
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var deferred = ZHPromise.defer();
        var dtemissao    = false;
        var dtentrada    = false;
        var dtprivencemp = false;
        var dtemprestimo = false;
        if (popupFilter.FILTER_ROW.hasOwnProperty('DTEMISSAO')){
            if (popupFilter.FILTER_ROW.DTEMISSAO.hasOwnProperty('start') && (popupFilter.FILTER_ROW.DTEMISSAO.start))
                dtemissao = true;
        }
        if (popupFilter.FILTER_ROW.hasOwnProperty('DTENTRADA')){
            if (popupFilter.FILTER_ROW.DTENTRADA.hasOwnProperty('start') && (popupFilter.FILTER_ROW.DTENTRADA.start))
                dtentrada = true;
        }
        if (popupFilter.FILTER_ROW.hasOwnProperty('DTPRIVENCEMP')){
            if (popupFilter.FILTER_ROW.DTPRIVENCEMP.hasOwnProperty('start') && (popupFilter.FILTER_ROW.DTPRIVENCEMP.start))
                dtprivencemp = true;
        }
        if (popupFilter.FILTER_ROW.hasOwnProperty('DTEMPRESTIMO')){
            if (popupFilter.FILTER_ROW.DTEMPRESTIMO.hasOwnProperty('start') && (popupFilter.FILTER_ROW.DTEMPRESTIMO.start))
                dtemprestimo = true;
        }
        emprestimo.dataSourceFilter.forEach(function(filter) {
            switch(filter.name) {
                case 'DTEMISSAOINI': filter.value = (dtemissao) ? popupFilter.FILTER_ROW.DTEMISSAO.start : null;
                    break;
                case 'DTEMISSAOFIN': filter.value = (dtemissao) ? popupFilter.FILTER_ROW.DTEMISSAO.end : null;
                    break;
                case 'TDTEMISSAO': filter.value = (dtemissao) ? null : 'T';
                    break;
                case 'DTENTRADAINI': filter.value = (dtentrada) ? popupFilter.FILTER_ROW.DTENTRADA.start : null;
                    break;
                case 'DTENTRADAFIN': filter.value = (dtentrada) ? popupFilter.FILTER_ROW.DTENTRADA.end : null;
                    break;
                case 'TDTENTRADA': filter.value = (dtentrada) ? null : 'T';
                    break;
                case 'DTVENCINI': filter.value = (dtprivencemp) ? popupFilter.FILTER_ROW.DTPRIVENCEMP.start : null;
                    break;
                case 'DTVENCFIN': filter.value = (dtprivencemp) ? popupFilter.FILTER_ROW.DTPRIVENCEMP.end : null;
                    break;
                case 'TDTATUAVENPAG': filter.value = (dtprivencemp) ? null : 'T';
                    break;
                case 'DTCONTRATOINI': filter.value = (dtemprestimo) ? popupFilter.FILTER_ROW.DTEMPRESTIMO.start : null;
                    break;
                case 'DTCONTRATOFIN': filter.value = (dtemprestimo) ? popupFilter.FILTER_ROW.DTEMPRESTIMO.end : null;
                    break;
                case 'TDTCONTRATOEMP': filter.value = (dtemprestimo) ? null : 'T';
                    break;
                case 'TNOTA': filter.value = (popupFilter.FILTER_ROW.NRNOTAFISCINI && popupFilter.FILTER_ROW.NRNOTAFISCFIN) ? null : 'T';
                    break;
                case 'TFILIORIG': filter.value = (popupFilter.FILTER_ROW.FILIORIG) ? null : 'T';
                    break;
                case 'TFILILANC': filter.value = (popupFilter.FILTER_ROW.FILILANC) ? null : 'T';
                    break;
                case 'TVRDOC': filter.value = (popupFilter.FILTER_ROW.VRDOCUINI && popupFilter.FILTER_ROW.VRDOCUFIN) ? null : 'T';
                    break;
                case 'TCDTPCTPAGAR': filter.value = (popupFilter.FILTER_ROW.CDTPCTPAGAR) ? null : 'T';
                    break;
                case 'TVRORIGPAG': filter.value = ((!popupFilter.FILTER_ROW.VRORIGINI) && (!popupFilter.FILTER_ROW.VRORIGFIN)) ? 'T' : null;
                    break;
                case 'TVRNOTAFISC': filter.value = ((!popupFilter.FILTER_ROW.VRLIQUINI) && (!popupFilter.FILTER_ROW.VRLIQUFIN)) ? 'T' : null;
                    break;
                case 'TVRTOTALEMP': filter.value = ((!popupFilter.FILTER_ROW.VREMPRINI) && (!popupFilter.FILTER_ROW.VREMPRFIN)) ? 'T' : null;
                    break;
                case 'TIDSTATPAG': filter.value = ((popupFilter.FILTER_ROW.IDSTATPAG) && (popupFilter.FILTER_ROW.IDSTATPAG != 'T')) ? null : 'T';
                    break;
                case 'TCDFORNECED': filter.value = (popupFilter.FILTER_ROW.CDFORNECED) ? null : 'T';
                    break;
                case 'SITUACAOVENCIDAS': filter.value = (popupFilter.FILTER_ROW.SITUACAO == '1') ? null : 'T';
                    break;
                case 'SITUACAOAVENCER': filter.value = (popupFilter.FILTER_ROW.SITUACAO == '0') ? null : 'T';
                    break;
                case 'IDSTATUS': var statusNota = '';
                    if (popupFilter.FILTER_ROW.IDSTATUS == 'A'){
                        statusNota = ['A', 'E'];
                    } else if (popupFilter.FILTER_ROW.IDSTATUS == 'V'){
                        statusNota = ['V'];
                    } else {
                        statusNota = null;
                    }
                    filter.value = statusNota;
                    break;
                case 'TIDSTATUS': filter.value = ( (!popupFilter.FILTER_ROW.hasOwnProperty(IDSTATUS)) || (popupFilter.FILTER_ROW.IDSTATUS == 'T')) ? 'T' : null;
                    break;
                default: break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.setValorFinal = function(widget, valorInicial, valorFinal){
        var novoValorInicial = (valorInicial.value()) ? valorInicial.value() : 0;
        valorInicial.setValue(novoValorInicial);
        widget.getField(valorFinal).setValue(valorInicial.value());
        /*var novoValorInicial = (valorInicial.value()) ? valorInicial.value() : 0;
        valorInicial.value(novoValorInicial);
        var min = (valorInicial.toString().search(',') == -1) ? parseFloat(valorInicial.value()) : parseFloat(valorInicial.value().toString().replace('.', '').replace(',', '.'));
        widget.getField(valorFinal).validations.range.min = min;*/
    };

    this.validaIsReload = function(componente){
        if (componente.isReload){
            componente.reload().then(function(){
                this.validaReloadComponente(componente, false);
            }.bind(this));
        }
    };

    this.validaReloadComponente = function(componente, status){
        componente.isReload = status;
    };

    this.openReparcelamento = function(){
        var tabbed_reparcelamento = templateManager.container.getWidget('tabbed_reparcelamento');
        var reparcelamento = templateManager.container.getWidget('reparcelamento');
        reparcelamento.dataSourceFilter[0].value = tabbed_reparcelamento.getParent().currentRow.CDFILIAL;
        reparcelamento.dataSourceFilter[1].value = tabbed_reparcelamento.getParent().currentRow.NRLANCTONF;
        reparcelamento.dataSourceFilter[2].value = tabbed_reparcelamento.getParent().currentRow.NRSEQVENPAG;
        ScreenService.openSwipe(tabbed_reparcelamento).then(function(){
            reparcelamento.reload().then(function(){
                reparcelamento.dataExclusao = [angular.copy(reparcelamento.dataSource.data[reparcelamento.dataSource.data.length - 1])];
            });
            reparcelamento.NOVOREPARCELAMENTO = false;
            this.validaVisibilidadeDeleteParcelas(reparcelamento);
        }.bind(this));
    };

    this.executaEdit = function(reparcelamento){
        General.widgetEdit(reparcelamento);
        reparcelamento.backupRow = angular.copy(reparcelamento.currentRow);
        reparcelamento.currentRow.edit = true;
    };

    this.validaSituacao = function(widget){
        var idstatpag = widget.getField('IDSTATPAG');
        var situacao = widget.getField('SITUACAO');
        if (idstatpag.value() == 'B'){
            situacao.readOnly = true;
        }else{
            situacao.readOnly = false;
        }
    };

    this.setDescricaoAjusteEmprestimo = function(widget){
        widget.currentRow.DSAJUSTEEMP = widget.currentRow.DSAJUCTPAG;
    };

    this.salvarEmprestimo = function () {
        var emprestimo = templateManager.container.getWidget('tabbed_emprestimo');
        var parcelas = templateManager.container.getWidget('parcelasGrid');
        var credito = templateManager.container.getWidget('credito');
        var route = 'fin_contaPagar#/saveEmprestimoPagar/save';
        var dataSet = [];
        if (emprestimo.isValid())
        {
            if (credito.isValid()){
                if (this.validaCondicoesEmprestimo(emprestimo, parcelas, credito)){
                    emprestimo.currentRow.CDTPGARANTIAEMP = (emprestimo.currentRow.hasOwnProperty('CDTPGARANTIAEMP')) ? emprestimo.currentRow.CDTPGARANTIAEMP : null;
                    dataSet.push(emprestimo.currentRow);
                    dataSet.push(parcelas.dataSource.data);
                    dataSet.push(credito.currentRow);
                    this.emprestimoRealizadoNoPeriodoContabil(emprestimo, emprestimo.currentRow.DTEMPRESTIMO).then(function(){
                        General.callRestEngine(route, 'DataSet', dataSet)
                        .then(
                            function () {
                                ScreenService.closeSwipe().then(function(){
                                    this.deleteValoresInsercaoEmprestimo();
                                    parcelas.getParent().isVisible = false;
                                    emprestimo.getParent().activate();
                                    emprestimo.getParent().reload();
                                    ScreenService.showMessage('Registro salvo com sucesso!');
                                }.bind(this));
                            }.bind(this)
                        )
                        .catch(
                            function (error) {
                                if (contabilizacaoController.checkErrosContabilizacao(error)) {
                                    ScreenService.showMessage(error.data.error);
                                }
                            }
                        );
                    }.bind(this))
                    .catch(function(error){
                        ScreenService.showMessage(error);
                    });
                }
            }else{
                credito.activate();
            }
        }
    };

    this.emprestimoRealizadoNoPeriodoContabil = function(emprestimo, dataReferencia){
        var deferred = ZHPromise.defer();
        var filtroContopectbl = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": emprestimo.currentRow.CDEMPRESA
        }];
        General.callRestEngine('fin#/crud/contopectbl', 'FilterData', filtroContopectbl).then(function(response){
            var contopectbl = response.dataset.contopectbl[0];
            var dtinicctbl  = contopectbl.DTINICCTBL;
            var dtfinacctbl = contopectbl.DTFINACCTBL;
            if(dtinicctbl && dtfinacctbl) {
                if ((moment(dtinicctbl, 'DD/MM/YYYY')) > (moment(dataReferencia, 'DD/MM/YYYY')) ||
                    (moment(dtfinacctbl, 'DD/MM/YYYY')) < (moment(dataReferencia, 'DD/MM/YYYY'))) {
                    deferred.reject('Operação Bloqueada. Data de entrada fora do período financeiro.');
                }else{
                    deferred.resolve();
                }
            }
        }.bind(this));
        return deferred.promise;
    };

    this.validaDatas = function(dataInicial, dataFinal){
        var inicial = dataInicial.split('/');
        var final = dataFinal.split('/');
        var anoIni = inicial.pop();
        var mesIni = inicial.pop();
        var diaIni = inicial.pop();
        var anoFim = final.pop();
        var mesFim = final.pop();
        var diaFim = final.pop();
        dataInicial = parseInt(anoIni.concat(mesIni.concat(diaIni)));
        dataFinal = parseInt(anoFim.concat(mesFim.concat(diaFim)));
        if (dataInicial <= dataFinal){
            return true;
        }else{
            return false;
        }
    };

    this.validaCondicoesEmprestimo = function(emprestimo, parcelas, credito){
        var emprestimoValido = true;
        var totalAjusteEmp = emprestimo.currentRow.VRTOTALAJUSTEMP;
        totalAjusteEmp = (totalAjusteEmp.toString().search(',') != -1) ? parseFloat(totalAjusteEmp.toString().replace('.', '').replace(',', '.')) : parseFloat(totalAjusteEmp);
        var valorEmprestimo = emprestimo.currentRow.VRTOTALEMP;
        valorEmprestimo = (valorEmprestimo.toString().search(',') != -1) ? parseFloat(valorEmprestimo.toString().replace('.', '').replace(',', '.')) : parseFloat(valorEmprestimo);
        var totalEmprestimo = (valorEmprestimo + totalAjusteEmp).toFixed(2);
        var totalParcelas = 0;
        var totalAjuste = 0;
        parcelas.dataSource.data.forEach(function(data){
            totalParcelas = parseFloat(totalParcelas) + parseFloat(data.VRFINALBPAG);
            totalAjuste = parseFloat(totalAjuste) + parseFloat(data.VRAJUSTE);
        });
        totalParcelas = totalParcelas.toFixed(2);
        totalAjuste = totalAjuste.toFixed(2);
        if ((totalEmprestimo != totalParcelas) && (emprestimoValido)){
            emprestimoValido = false;
            ScreenService.showMessage("A soma das parcelas difere do valor total do empréstimo.");
        }
        if ((parseFloat(totalAjusteEmp).toFixed(2) != totalAjuste) && (emprestimoValido)){
            emprestimoValido = false;
            ScreenService.showMessage("A soma dos ajustes das contas difere do total de juros do empréstimo.");
        }
        if ((credito.currentRow.CREDITO == 'S') && (emprestimoValido)){
            if (credito.currentRow.DTMOVICRED){
                if (!this.validaDatas(emprestimo.currentRow.DTEMPRESTIMO, credito.currentRow.DTMOVICRED)){
                    emprestimoValido = false;
                    ScreenService.showMessage("Data do lançamento de crédito deve ser maior ou igual à data do empréstimo");
                }
            }
        }
        if ((credito.currentRow.DEBIOF == 'S') && (emprestimoValido)){
            if (credito.currentRow.DTMOVIDEBI){
                if (!this.validaDatas(emprestimo.currentRow.DTEMPRESTIMO, credito.currentRow.DTMOVIDEBI)){
                    emprestimoValido = false;
                    ScreenService.showMessage("Data do lançamento de débito deve ser maior ou igual à data do empréstimo");
                }
            }
        }
        if (credito.currentRow.DEBIOF && emprestimoValido){
            if (parseFloat(credito.currentRow.VRMOVIDEBI) > parseFloat(valorEmprestimo)){
                emprestimoValido = false;
                ScreenService.showMessage("Valor do débito deve ser menor que o valor do empréstimo.");
            }
        }
        if (emprestimoValido){
            emprestimoValido = this.validaDatacontratoMenorVencimento(emprestimo);
        }
        return emprestimoValido;
    };

    this.validaCondicoesReparcelamento = function(parcelas, reparcelamento){
        var reparcelamentoValido = true;
        var totalAjuste = 0;
        var totalConta = 0;
        var dataReparcelamento = reparcelamento.dataSource.data.filter(function(data){
            return data.__createdLocal || data.changed;
        });
        dataReparcelamento.forEach(function(parcela){
            var valorConta = parcela.VRATUAPAG;
            valorConta = (valorConta.toString().search(',') == -1) ? parseFloat(valorConta) : parseFloat(valorConta.toString().replace('.', '').replace(',', '.'));
            totalConta = (parseFloat(totalConta) + parseFloat(valorConta)).toFixed(2);
            valorAjuste = parcela.VRAJUSTE;
            valorAjuste = (valorAjuste.toString().search(',') == -1) ? parseFloat(valorAjuste) : parseFloat(valorAjuste.toString().replace('.', '').replace(',', '.'));
            totalAjuste = (parseFloat(totalAjuste) + parseFloat(valorAjuste)).toFixed(2);
        });

        if ((parseFloat(parcelas.currentRow.VRAJUSTE) != parseFloat(totalAjuste)) && reparcelamentoValido){
            reparcelamentoValido = false;
            ScreenService.showMessage("A soma dos ajustes dos boletos difere do total de juros da conta.");
        }
        var totalTitulo = parseFloat(parcelas.currentRow.VRATUAPAG);
        totalConta = parseFloat(totalConta);
        if (totalTitulo != totalConta){
            reparcelamentoValido = false;
            var diferencaValores =
                'Total das parcelas difere do valor total do título.<br/><br/>Valor Total Título: ' + totalTitulo + '<br/>'+
                'Valor Total Parcelas: ' + totalConta + '<br/>' + 'Diferença de Valor: ' + (totalTitulo - totalConta).toFixed(2) + '.';
            ScreenService.showMessage(diferencaValores);
        }

        return reparcelamentoValido;
    };

    this.deleteValoresInsercaoEmprestimo = function(){
        templateManager.container.getWidget('tabbed_emprestimo').currentRow = {};
        templateManager.container.getWidget('parcelasGrid').dataSource.data = [];
        templateManager.container.getWidget('credito').currentRow = {};
    };



    this.salvarReparcelamentoEmprestimo = function () {
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var parcelas = templateManager.container.getWidget('parcelas');
        var reparcelamento = templateManager.container.getWidget('reparcelamento');
        var route = 'fin_contaPagar#/saveReparcelamentoEmprestimoPagar/save';
        var dataSet = [];
        if (this.validaCondicoesReparcelamento(parcelas, reparcelamento)){
            dataSet = this.preparaDataSetReparcelamento(emprestimo, parcelas, reparcelamento);
            General.callRestEngine(route, 'DataSet', dataSet)
            .then(
                function () {
                    reparcelamento.NOVOREPARCELAMENTO = true;
                    ScreenService.closeSwipe().then(function(){
                        reparcelamento.reload();
                        parcelas.reload();
                        parcelas.activate();
                        General.changeWidgetAcessibility(reparcelamento.widgets, true);
                        ScreenService.showMessage('Parcelamento salvo com sucesso!');
                    }.bind(this));
                }
            )
            .catch(
                function (error) {
                    if (contabilizacaoController.checkErrosContabilizacao(error)) {
                        ScreenService.showMessage(error.data.error);
                    }
                }
            );
        }
    };

    this.preparaDataSetReparcelamento = function(emprestimo, parcelas, reparcelamento){
        var dataSet = [];
        dataSet.push(emprestimo.currentRow);
        reparcelamento.dataExclusao.forEach(function(data){
            data.CDAJUCTPAG = emprestimo.currentRow.CDAJUCTPAG;
            data.CDEMPRESA = emprestimo.currentRow.CDEMPRESA;
            data.CDFIMOVFLPAG = parcelas.currentRow.CDFIMOVFLPAG;
            data.CDFILIAL = parcelas.currentRow.CDFILIAL;
            data.CDCLASSFINA = parcelas.currentRow.CDCLASSFINA;
            data.NRLANCTONF = parcelas.currentRow.NRLANCTONF;
        });
        dataSet.push(reparcelamento.dataExclusao);
        var dataInclusao = reparcelamento.dataSource.data.filter(function(parcela){
            return parcela.__createdLocal || parcela.changed;
        });
        dataInclusao.forEach(function(data){
            data.CDAJUCTPAG = emprestimo.currentRow.CDAJUCTPAG;
            data.CDEMPRESA = emprestimo.currentRow.CDEMPRESA;
            data.CDFIMOVFLPAG = parcelas.currentRow.CDFIMOVFLPAG;
            data.CDFILIAL = parcelas.currentRow.CDFILIAL;
            data.CDCLASSFINA = parcelas.currentRow.CDCLASSFINA;
            data.NRLANCTONF = parcelas.currentRow.NRLANCTONF;
        });
        dataSet.push(dataInclusao);
        return dataSet;
    };

    /*this.deleteEmprestimo = function (widget) {
        var route = 'fin_contaPagar#/deleteEmprestimoPagar';
        var dataSet = [];
        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir Empréstimo?'), 'question', function () {
            General.callRestEngine(route, 'DataSet', dataSet)
                .then(function () {
                    ScreenService.closeSwipe().then(function(){
                        widget.reload();
                        ScreenService.showMessage('Registro excluído com sucesso!');
                    });
                })
                .catch(function (response) {
                    ScreenService.showMessage(response.data.error);
                });
        });
    };*/

    this.deleteDocumentoEmprestimoPagar = function (widget) {
        var route = 'fin_contaPagar#/deleteDocumentoEmprestimoPagar';
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var parcelas = templateManager.container.getWidget('parcelas');
        var credito = templateManager.container.getWidget('lancamentoIof');
        var rowCredito = {};
        var rowDebIof = {};
        rowCredito = this.preparaRowCredito(credito.currentRow, rowCredito);
        rowDebIof = this.preparaRowDebito(credito.currentRow, rowDebIof);
        var dataSet = [];
        dataSet.push(emprestimo.currentRow);
        dataSet.push(parcelas.dataSource.data);
        dataSet.push(rowCredito);
        dataSet.push(rowDebIof);
        if (this.validaStatusEmprestimo(emprestimo)){
            this.emprestimoRealizadoNoPeriodoContabil(emprestimo).then(function(){
                ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir o Empréstimo?'), 'question', function () {
                    General.callRestEngine(route, 'DataSet', dataSet)
                        .then(function () {
                            ScreenService.closeSwipe().then(function(){
                                widget.reload();
                                ScreenService.showMessage('Registro excluído com sucesso!');
                            });
                        })
                        .catch(function (response) {
                            ScreenService.showMessage(response.data.error);
                        });
                });
            }.bind(this))
            .catch(function (error) {
                ScreenService.showMessage(error);
            });

        }
    };

    this.validaStatusEmprestimo = function($emprestimo){
        var statusValido = true;
        if ($emprestimo.currentRow.IDBPAGREAL == 'S'){
            statusValido = false;
            ScreenService.showMessage('Conta relacionada a um boleto real não pode ser alterada');
        }
        return statusValido;
    };

    this.deleteParcelaEmprestimoPagar = function () {
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var parcelas = templateManager.container.getWidget('parcelas');
        var route = 'fin_contaPagar#/deleteParcelaEmprestimoPagar';
        var routeGrupoOperadores = 'fin_contaPagar#/verificaGrupoOperadores';
        this.emprestimoRealizadoNoPeriodoContabil(emprestimo).then(function(){
            if (this.validaCondicoesExclusaoParcelas(parcelas)){
                var dataDelete = angular.copy(parcelas.getCheckedRows());
                dataDelete.forEach(function(data){
                    data.CDAJUCTPAG = emprestimo.currentRow.CDAJUCTPAG;
                });
                General.callRestEngine(routeGrupoOperadores, 'Row', {}).then(function(grupoOper){
                    if (grupoOper.dataset.STATUS[0]){
                        this.validaStatusPagamento(dataDelete.IDSTATPAG);
                    }else{
                        ScreenService.confirmMessage(ScreenService.i18n('Confirmar exclusão da(s) parcela(s)?'), 'question', function () {
                            General.callRestEngine(route, 'DataSet', dataDelete)
                            .then(function () {
                                parcelas.reload().then(function(){
                                    var totalParcelas = 0;
                                    parcelas.dataSource.data.forEach(function(parcela){
                                        totalParcelas = parseFloat(totalParcelas) + parseFloat(parcela.VRATUAPAG);
                                    });
                                    emprestimo.currentRow.VRTOTALEMP = (totalParcelas).toFixed(2);
                                    //emprestimo.reload([], false);
                                }.bind(this));
                                ScreenService.showMessage('Registro excluído com sucesso!');
                            }.bind(this))
                            .catch(function (response) {
                                ScreenService.showMessage(response.data.error);
                            });
                        });
                    }
                }.bind(this));
            }
        }.bind(this))
        .catch(function (error) {
            ScreenService.showMessage(error);
        });
    };

    this.validaCondicoesExclusaoParcelas = function(parcelas){
        var condicaoValida = true;
        var qtdeRowsMarcadas = parcelas.getCheckedRows().length;
        var qtdeRows = parcelas.dataSource.data.length;
        if (qtdeRows == 1){
            condicaoValida = false;
            ScreenService.showMessage('Operação bloqueada! Empréstimo possui apenas um vencimento.');
        }
        if ((qtdeRows == qtdeRowsMarcadas) && (condicaoValida)){
            condicaoValida = false;
            ScreenService.showMessage('Operação bloqueada! Não é possível excluir todos os vencimentos.');
        }
        return condicaoValida;
    };

    this.validaStatusPagamento = function(idstatpag){
        if ((idstatpag == 'A') || (idstatpag == 'E')){
            ScreenService.showMessage('Operação bloqueada! Operador não possui permissão para excluir conta do tipo real.');
        }else{
            if (idstatpag == 'V'){
                ScreenService.showMessage('Operação bloqueada! Operador não possui permissão para excluir conta do tipo previsto.');
            }else{
                ScreenService.showMessage('Operação bloqueada! Operador não possui permissão excluir o tipo de conta.');
            }
        }
    };

    this.adicionaEmprestimo = function(){
        var tabbed = templateManager.container.getWidget('tabbed_emprestimo');
        var emprestimo = templateManager.container.getWidget('emprestimo');
        var credito = templateManager.container.getWidget('credito');
        var parcelasGrid = templateManager.container.getWidget('parcelasGrid');
        credito.getField('DSCONTCORR').dataSourceFilter[0].value = emprestimo.appliedFilter.FILTER_ROW.CDEMPRESA;
        credito.getField('DSCONTCORRCRED').dataSourceFilter[0].value = emprestimo.appliedFilter.FILTER_ROW.CDEMPRESA;
        ScreenService.openSwipe(tabbed).then(function(){
            tabbed.isVisible = true;
            //parcelasGrid.edit();
            credito.edit();
            tabbed.currentRow.CDEMPRESA = emprestimo.appliedFilter.FILTER_ROW.CDEMPRESA;
            tabbed.getField('DTEMPRESTIMO').setValue(moment().format('DD/MM/YYYY'));
            tabbed.getField('DTPRIVENCEMP').setValue(moment().format('DD/MM/YYYY'));
            tabbed.getField('IDMOVFLUXO').setValue('E');
            tabbed.getField('IDTIPOEMP').setValue('O');
            tabbed.getField('NMFILIAL').dataSourceFilter[0].value = emprestimo.appliedFilter.FILTER_ROW.CDEMPRESA;
            tabbed.getField('VRTOTALAJUSTEMP').setValue(0);
            tabbed.getField('VRTXJUROSEMP').setValue(0);
            tabbed.getField('IDTIPOEMP').setValue('O');
            credito.getField('DTMOVICRED').setValue(moment().format('DD/MM/YYYY'));
            credito.getField('DTMOVIDEBI').setValue(moment().format('DD/MM/YYYY'));
            credito.getField('DEBIOF').setValue('S');
            credito.getField('CREDITO').setValue('S');
            this.validaDisponibilidadeDebCredIOF(credito, 'CREDITO');
            this.validaDisponibilidadeDebCredIOF(credito, 'DEBIOF');
            tabbed.redraw();
        }.bind(this));
    };

    this.cancelEmprestimo = function(){
        var tabbed = templateManager.container.getWidget('tabbed_emprestimo');
        ScreenService.closeSwipe().then(function(){
            this.deleteValoresInsercaoEmprestimo();
            tabbed.isVisible = false;
            tabbed.getParent().activate();
            tabbed.widgets[0].dataSource.data = [];
        }.bind(this));
    };

    this.aplicaFiltroParcelas = function(emprestimo){
        var parcelas = templateManager.container.getWidget('parcelas');
        var lancamentoIof = templateManager.container.getWidget('lancamentoIof');
        parcelas.dataSourceFilter[0].value = emprestimo.currentRow.CDEMPRESA;
        parcelas.dataSourceFilter[1].value = emprestimo.currentRow.NRSEQUENCIALEMP;
        parcelas.dataSourceFilter[2].value = emprestimo.currentRow.CDFILIAL;
        parcelas.reload();
        lancamentoIof.dataSourceFilter[0].value = emprestimo.currentRow.CDEMPRESA;
        lancamentoIof.dataSourceFilter[1].value = emprestimo.currentRow.NRSEQUENCIALEMP;
        lancamentoIof.dataSource.data = [];
        lancamentoIof.reload([], false).then(function(){
            this.setLancamentoCreditoDebitoIof(lancamentoIof);
        }.bind(this));
    };

    this.setLancamentoCreditoDebitoIof = function(lancamentoIof){
        var row = {};
        if (lancamentoIof.dataSource.data.length > 0){
            if (lancamentoIof.dataSource.data.length > 1){
                lancamentoIof.dataSource.data[0].DEBIOF = 'S';
                lancamentoIof.dataSource.data[1].CREDITO = 'S';
                row = this.preparaRowDebito(lancamentoIof.dataSource.data[0], row);
                row = this.preparaRowCredito(lancamentoIof.dataSource.data[1], row);
            }else{
                if (lancamentoIof.dataSource.data[0].VRMOVIDEBI){
                    lancamentoIof.dataSource.data[0].DEBIOF = 'S';
                    lancamentoIof.dataSource.data[0].CREDITO = 'N';
                    row = this.preparaRowDebito(lancamentoIof.dataSource.data[0], row);
                }else{
                    lancamentoIof.dataSource.data[0].DEBIOF = 'N';
                    lancamentoIof.dataSource.data[0].CREDITO = 'S';
                    row = this.preparaRowCredito(lancamentoIof.dataSource.data[0], row);
                }
            }
        }else{
            row.DEBIOF = 'N';
            row.CREDITO = 'N';
            row.NRLCTBMCRED = null;
            row.NRLCTBMDEB = null;
        }
        lancamentoIof.currentRow = row;
    };

    this.preparaRowCredito = function(currentRow, row){
        row.CREDITO = currentRow.CREDITO;
        row.CDCONTCTBLCRED = currentRow.CDCONTCTBLCRED;
        row.CDREDUCONTCRED = currentRow.CDREDUCONTCRED;
        row.DTMOVICRED = currentRow.DTMOVICRED;
        row.NRLCTBMCRED = currentRow.NRLCTBMCRED;
        row.DSCONTCORRCRED = currentRow.DSCONTCORRCRED;
        row.CDBANCOCRED = currentRow.CDBANCOCRED;
        row.CDAGENCIACRED = currentRow.CDAGENCIACRED;
        row.CDCONTCORRCRED = currentRow.CDCONTCORRCRED;
        row.NRDOCMBANCCRED = currentRow.NRDOCMBANCCRED;
        row.DSMOVICRED = currentRow.DSMOVICRED;
        row.DSTPCREDBANC = currentRow.DSTPCREDBANC;
        row.VRMOVICRED = currentRow.VRMOVICRED;
        row.NRSEQMOVREBACRED = currentRow.NRSEQMOVREBACRED;
        row.CDSEQUEXBACRED = currentRow.CDSEQUEXBACRED;
        row.NRMOVBANCCRED = currentRow.NRMOVBANCCRED;
        return row;
    };

    this.preparaRowDebito = function(currentRow, row){
        row.DEBIOF = currentRow.DEBIOF;
        row.CDREDUCONT = currentRow.CDREDUCONT;
        row.CDCONTCTBL = currentRow.CDCONTCTBL;
        row.DTMOVIDEBI = currentRow.DTMOVIDEBI;
        row.NRLCTBMDEB = currentRow.NRLCTBMDEB;
        row.DSCONTCORR = currentRow.DSCONTCORR;
        row.CDBANCO = currentRow.CDBANCO;
        row.CDAGENCIA = currentRow.CDAGENCIA;
        row.CDCONTCORR = currentRow.CDCONTCORR;
        row.NRDOCMBANC = currentRow.NRDOCMBANC;
        row.DSMOVIDEBI = currentRow.DSMOVIDEBI;
        row.DSTPDEBIBANC = currentRow.DSTPDEBIBANC;
        row.VRMOVIDEBI = currentRow.VRMOVIDEBI;
        row.NRSEQMOVREBA = currentRow.NRSEQMOVREBA;
        row.CDSEQUEXBA = currentRow.CDSEQUEXBA;
        row.NRMOVBANC = currentRow.NRMOVBANC;
        return row;
    };

    self.formataValoresDecimais = function(valor){
        var valorFormatado = 0;
        valorFormatado = (valor.toString().search(',') != '-1') ?
            ((parseFloat(valor.toString().split(',')[0]) > 0) ? parseFloat(valor.toString().replace('.', '').replace(',', '.')) : parseFloat(valor.toString().replace(',', '.'))) :
            parseFloat(valor);
        return valorFormatado;
    };

    this.setaMascCnpjCpfFornecedor = function(widget) {
	    var data = widget.dataSource.data;
	    var inscFormatada;
	    data.forEach(function(value){
	        if(value.NRINSJURFORN.length === 14) inscFormatada = value.NRINSJURFORN.substr(0, 2) + '.' + value.NRINSJURFORN.substr(2, 3) + '.' + value.NRINSJURFORN.substr(5, 3) + '/' + value.NRINSJURFORN.substr(8, 4) + '-' + value.NRINSJURFORN.substr(12, 2);
          else if(value.NRINSJURFORN.length === 11) inscFormatada = value.NRINSJURFORN.substr(0, 3) + '.' + value.NRINSJURFORN.substr(3, 3) + '.' + value.NRINSJURFORN.substr(6, 3) + '-' + value.NRINSJURFORN.substr(9, 2);
          else inscFormatada = null;
          value.NRINSJURFORN = inscFormatada?inscFormatada:value.NRINSJURFORN;
	    });
	};
	
	this.onChangeEmpresaFilter = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var cdtpctpagar = widget.getField('CDTPCTPAGAR');
        
        cdtpctpagar.setValue("");
        cdtpctpagar.dataSourceFilter[1].value = cdempresa;
        cdtpctpagar.reload();
    };
	
	self.editarEmprestimoLeasing = function(){
	    var emprestimoWidget = templateManager.container.getWidget('emprestimo');
	    var parcelasWidget = templateManager.container.getWidget('parcelas');
        var creditoWidget = templateManager.container.getWidget('lancamentoIof');
        
        parcelasWidget.enabled = false;
        creditoWidget.enabled = false;
        General.edit(emprestimoWidget);
	};
	
	self.salvarEditEmprestimoLeasing = function(){
	    var parcelasWidget = templateManager.container.getWidget('parcelas');
        var creditoWidget = templateManager.container.getWidget('lancamentoIof');
        
        parcelasWidget.enabled = true;
        creditoWidget.enabled = true;
	};
	
	self.CancelarEditEmprestimoLeasing = function(){
	    var parcelasWidget = templateManager.container.getWidget('parcelas');
        var creditoWidget = templateManager.container.getWidget('lancamentoIof');
        
        parcelasWidget.enabled = true;
        creditoWidget.enabled = true;
	};
	
	self.VoltarButtonParcelasAndCredito = function(){
	    var emprestimoWidget = templateManager.container.getWidget('emprestimo');
	    
	    ScreenService.goBack();
        emprestimoWidget.activate();
	};
	
	self.setStripe = function(){
	   var emprestimoWidget = templateManager.container.getWidget('emprestimo');
	   var stripeWidget = templateManager.container.getWidget('stripe');
	   
	   stripeWidget.currentRow.EMPRESA  = emprestimoWidget.appliedFilter.FILTER_ROW.NMEMPRESA ;
	   
	};

};

Configuration(function (ContextRegister){
    ContextRegister.register('Pag16000_EmprestimoLeasing_Controller', Pag16000_EmprestimoLeasing_Controller);
});